/* --------------  Global definisions ------------- */
#define CircleStartX             25
#define CircleStartY             25
#define CircleRadius             15
#define RectStartX               320
#define RectStartY               75
#define RectStartW               50
#define RectStartH               100
#define WINDOW_SIZE              600
#define SenseArea                7.0/100  /* 7% of sensitive area  */
#define MIN_WIDTH                2   /* Minimum width(/height) of rect. */

#define INIT_STATE  {{0.0, 0.0},{0.0,0.0},NONE,Outside,{(float)CircleStartX, 0.0}}
/* (FilledCircle.y will be updated in real time) */

#define TRUE                     1
#define FALSE                    0

/* ---------------  Activities  ------------------- */
#define NONE                     0
#define TRAN                     1
#define SCALE                    2
#define ROTATE                   3
#define DRAG_CIRCLE              4


typedef struct state_s {
   Vec2f coord          ;
   Vec2f SCenter        ;
   int activity         ;
   int Area             ;  
   Vec2f FilledCircle   ;
   } state;

/* ---------------  Sensitive areas  ------------------- */
#define InCorner00     0
#define InCorner11     1
#define InCorner10     2
#define InCorner01     3
#define InMiddle       4
#define InEdge         5
#define InCircle       6
#define Outside        7

